import { krl, KrlCtx } from "krl-stdlib";
import { RulesetContext } from "pico-framework";
import { PicoEngineCore } from "./PicoEngineCore";
import { CachedRuleset } from "./RulesetRegistry";
export declare class CorePico {
    private core;
    dependencies: {
        [rid: string]: {
            krlCtx: KrlCtx;
            uses: {
                [usesRid: string]: {
                    [alias: string]: {
                        configure?: {
                            [name: string]: any;
                        };
                        url: string;
                        hash: string;
                        module: krl.Module;
                    };
                };
            };
        };
    };
    constructor(core: PicoEngineCore);
    use(krlCtx: KrlCtx, usesRid: string, alias?: string | null, configure?: {
        [name: string]: any;
    }): Promise<void>;
    configure(rsCtx: RulesetContext, name: string, dflt: any): any;
    getModule(userRid: string, domain: string): krl.Module | null;
    whoUses(rid: string): string[];
    unUse(rid: string): void;
    onRulesetLoaded(crs: CachedRuleset): void;
}
