import { krl, KrlLogger, PicoLogEntry } from "krl-stdlib";
import { PicoEvent, PicoFramework, PicoQuery } from "pico-framework";
import { CorePico } from "./CorePico";
import { CoreEventOutput } from "./formatEventOutput";
import { PicoEngineCoreConfiguration } from "./PicoEngineCoreConfiguration";
import { CachedRuleset, RulesetRegistry } from "./RulesetRegistry";
export declare class PicoEngineCore {
    readonly version: string;
    log: KrlLogger;
    rsRegistry: RulesetRegistry;
    getPicoLogs: (picoId: string) => Promise<PicoLogEntry[]>;
    modules: {
        [domain: string]: krl.Module;
    };
    base_url: string | undefined;
    picoFramework: PicoFramework;
    private picos;
    private startupModules;
    constructor(conf: PicoEngineCoreConfiguration);
    start(): Promise<void>;
    onRulesetLoaded(crs: CachedRuleset): void;
    addPico(picoId: string): CorePico;
    getPico(picoId: string): CorePico | null;
    event(event: PicoEvent): Promise<string>;
    eventWait(event: PicoEvent): Promise<CoreEventOutput>;
    eventQuery(event: PicoEvent, query: PicoQuery): Promise<any>;
    query(query: PicoQuery): Promise<any>;
}
