"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RulesetRegistryLoaderMem = void 0;
const krlCompiler = require("krl-compiler");
const krlCompilerVersion = require("krl-compiler/package.json").version;
function RulesetRegistryLoaderMem(fetchKrl) {
    const urlData = {};
    return {
        fetchKrl,
        async save(data) {
            urlData[data.url] = data;
        },
        async compileAndLoad(url, krl, hash) {
            const out = krlCompiler(krl);
            if (typeof out.rid !== "string") {
                throw new Error("Compile failed, missing rid");
            }
            const ruleset = eval(out.code);
            return {
                ruleset,
                compiler: { version: krlCompilerVersion, warnings: out.warnings },
            };
        },
        async attemptLoad(url) {
            return urlData[url] || null;
        },
    };
}
exports.RulesetRegistryLoaderMem = RulesetRegistryLoaderMem;
//# sourceMappingURL=RulesetRegistryLoaderMem.js.map