import { krl } from "krl-stdlib";
import { RulesetConfig } from "pico-framework";
import { PicoEngineCore } from "../PicoEngineCore";
export interface RulesetCtxInfo {
    rid: string;
    config: RulesetConfig | null;
    url: string;
    meta: RulesetCtxInfoMeta | null;
}
export interface RulesetCtxInfoMeta {
    krl: string;
    krlMeta?: {
        version?: string;
        name?: string;
        description?: string;
        author?: string;
    };
    hash: string;
    flushed: Date;
    compiler: {
        version: string;
        warnings: any[];
    };
}
export default function initCtxModule(core: PicoEngineCore): krl.Module;
