"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const krl_stdlib_1 = require("krl-stdlib");
function initMetaModule(core) {
    const meta = {
        eci: krl_stdlib_1.krl.Property(function eci() {
            const event = this.getEvent();
            const query = this.getQuery();
            return event ? event.eci : query ? query.eci : null;
        }),
        host: krl_stdlib_1.krl.Property(function host() {
            return core.base_url;
        }),
        inEvent: krl_stdlib_1.krl.Property(function rid() {
            return this.getEvent() ? true : false;
        }),
        inQuery: krl_stdlib_1.krl.Property(function rid() {
            return this.getQuery() ? true : false;
        }),
        picoId: krl_stdlib_1.krl.Property(function rid() {
            return this.rsCtx.pico().id;
        }),
        rid: krl_stdlib_1.krl.Property(function rid() {
            return this.rsCtx.ruleset.rid;
        }),
        ruleName: krl_stdlib_1.krl.Property(function rid() {
            return this.getCurrentRuleName();
        }),
        rid_url: krl_stdlib_1.krl.Property(function rid_url() {
            return this.rsCtx.ruleset.config["url"];
        }),
        rulesetURI: krl_stdlib_1.krl.Property(function rid_url() {
            return this.rsCtx.ruleset.config["url"];
        }),
        txnId: krl_stdlib_1.krl.Property(function txnId() {
            const event = this.getEvent();
            const query = this.getQuery();
            return event ? event.eid : query ? query.qid : null;
        }),
        rulesetConfig: krl_stdlib_1.krl.Property(function rid_config() {
            return this.rsCtx.ruleset.config["config"];
        }),
    };
    return meta;
}
exports.default = initMetaModule;
//# sourceMappingURL=meta.js.map