"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const cuid = require("cuid");
const krl_stdlib_1 = require("krl-stdlib");
const _ = require("lodash");
const randomWords = require("random-words");
var fixLowerUpperArgs = function (upper, lower, round = false) {
    var lowerNum = krl_stdlib_1.krl.toNumberOrNull(lower);
    if (round && lowerNum !== null) {
        lowerNum = _.round(lowerNum);
    }
    var upperNum = krl_stdlib_1.krl.toNumberOrNull(upper);
    if (round && upperNum !== null) {
        upperNum = _.round(upperNum);
    }
    var upper;
    if (upperNum === null) {
        upper = lowerNum === null ? 1 : 0;
    }
    else {
        upper = upperNum;
    }
    return {
        lower: lowerNum === null ? 0 : lowerNum,
        upper: upper,
    };
};
const random = {
    uuid: krl_stdlib_1.krl.Function([], function () {
        return cuid();
    }),
    word: krl_stdlib_1.krl.Function([], function () {
        return randomWords();
    }),
    integer: krl_stdlib_1.krl.Function(["upper", "lower"], function (upper, lower) {
        var args = fixLowerUpperArgs(upper, lower, true);
        return _.random(args.lower, args.upper);
    }),
    number: krl_stdlib_1.krl.Function(["upper", "lower"], function (upper, lower) {
        var args = fixLowerUpperArgs(upper, lower);
        return _.random(args.lower, args.upper, true);
    }),
};
exports.default = random;
//# sourceMappingURL=random.js.map